<template>
  <div class="q-pa-md">
    <q-table
      title="Categorys"
      :data="categorys"
      row-key="id"
      :selected-rows-label="getSelectedString"
      :columns="columns"
      selection="multiple"
      :selected.sync="selected"
    >
      <template v-slot:body-cell-action="categorys">
        <q-td :categorys="categorys" align="left" width="20px">
          <q-btn
            color="primary"
            icon="edit"
            @click="ShowEditModal(categorys.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          <q-btn
            color="red"
            icon="delete"
            @click="ShowDeleteModal(categorys.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      <template v-slot:top>
        <q-btn
          color="primary"
          :disable="loading"
          label="Add Category"
          @click="ShowAddModal()"
        />
        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="negative"
          :disable="loading"
          label="Delete category"
          @click="ShowMoreDeleteModal()"
        />
        <q-space />
        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="search_text"
          v-on:keyup="filterFn"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="filter"
            />
          </template>
        </q-input>
      </template>
    </q-table>

    <!-- Modallar Dialog -->
    <!-- Add Dialog -->
    <q-dialog v-model="AddModal" persistent>
      <q-layout view="hHh lpR fFf" container style="max-width: 350px; height:200px" class=" q-mb-md rounded-borders bg-white">
        <q-header class="bg-white">
          <q-toolbar>
            <!-- <q-btn flat round dense icon="menu" /> -->
            <q-toolbar-title align="center"  class="text-primary bg-white">
              <div class="text-h6">New Category</div>
            </q-toolbar-title>
          </q-toolbar>
        </q-header>
        <q-page-container>
          <q-page class="bg-white">
            <q-card-section class="q-pt-none">
              <div class="text-h7">Name</div>
              <q-input dense v-model="AddData.name" autofocus />
            </q-card-section>
          </q-page>
        </q-page-container>
        <q-footer  >
          <q-toolbar class="bg-white">
            <q-toolbar-title align="right"  class="text-primary bg-write bg-white">
              <q-btn flat label="Create" @click="SendAddData"/>
              <q-btn flat label="Cancel" @click="CloseAddModle()"/>
            </q-toolbar-title>
          </q-toolbar>
        </q-footer>
      </q-layout>
    </q-dialog>
    <!-- End Add Dialog -->
    <!-- Edit Dialog -->
    <q-dialog v-model="EditModal" persistent>
      <q-layout view="hHh lpR fFf" container style="max-width: 350px; height:200px" class=" q-mb-md rounded-borders bg-white">
        <q-header class="bg-white">
          <q-toolbar>
            <!-- <q-btn flat round dense icon="menu" /> -->
            <q-toolbar-title align="center"  class="text-primary bg-white">
              <div class="text-h6">Update Category</div>
            </q-toolbar-title>
          </q-toolbar>
        </q-header>
        <q-page-container>
          <q-page class="bg-white">
            <q-card-section class="q-pt-none">
              <div class="text-h7">Name</div>
              <q-input dense
            v-model="EditData.name"
            autofocus
            @keyup.enter="SendEditData"
            @keyup.esc="EditModal = false" />
            </q-card-section>
          </q-page>
        </q-page-container>
        <q-footer  >
          <q-toolbar class="bg-white">
            <!-- <q-btn flat round dense icon="menu" /> -->
            <q-toolbar-title align="right"  class="text-primary bg-write bg-white">
              <q-btn flat label="Create" @click="SendEditData"/>
              <q-btn flat label="Cancel" @click="CloseEditModle()"/>
            </q-toolbar-title>
          </q-toolbar>
        </q-footer>
      </q-layout>
    </q-dialog>
    <!-- End Edit Dialog -->
    <!-- Delete Dialog -->
    <q-dialog v-model="DeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendDeleteData"
        @keyup.esc="DeleteModal = false"
      >
        <q-card-section>
          <div class="text-h6">Delete categorys</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">You agree to delete this information?</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">Name:{{ DeleteData.name }}</div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendDeleteData" />
          <q-btn flat label="Cancel" @click="DeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Delete Dialog -->
    <!-- Start Multi Delete Modal  -->
    <q-dialog v-model="multiDeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="selected.id"
        @keyup.esc="multiDeleteModal = false"
      >
        <q-card-section class="bg-deep-orange text-white">
          <div class="text-h6">Are you sure delete this Categories ?</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-md">
            <div v-for="(selects, i) in selected" :key="i">
              <div class="row">
                <div class="row">
                  <p class="text-weight-bold q-pr-sm">{{ i + 1 }}. Name :</p>
                  {{ selects.name }}
                </div>
              </div>
            </div>
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="red" label="Delete" @click="sendmultiDelete" />
          <q-btn flat label="Cancel" @click="multiDeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Multi Delete Modal  -->
  </div>
</template>

<script>
import axios from 'axios'
import { Notify } from 'quasar'

export default {
  name: 'PageIndex',
  data () {
    return {
      password_error: false,
      search_text: '',
      categorys: [],
      allcategorys: [],
      selected: [],
      columns: [
        {
          name: 'index',
          label: '#',
          field: 'index',
          align: 'left',
          style: 'width: 10px',
          sortable: true
        },
        {
          name: 'name',
          field: 'name',
          label: 'Category Name',
          align: 'left',
          sortable: true
        },
        {
          name: 'action',
          label: 'Action',
          align: 'left',
          style: 'width: 20px !important'
        }
      ],
      AddModal: false,
      AddData: {
        id: '',
        name: ''
      },
      EditModal: false,
      EditData: [],
      DeleteModal: false,
      multiDeleteModal: false,
      DeleteData: []
    }
  },
  async mounted () {
    this.$q.loading.show({
      delay: 400 // ms
    })
    this.category()
    this.$q.loading.hide()
  },
  methods: {
    
    
    async category () {
      this.categorys=[]
      await axios
        .get('http://127.0.0.1:10/api/category/get_category')
        .then((response) => {
          var data = response.data
          for (var i = 0; i < data.length; i++) {
            var json = {
              index: i + 1,
              id: data[i].id,
              name: data[i].name
            }
            this.categorys.push(json)
            this.allcategorys = this.categorys
            console.log(this.categorys)
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          Notify.create({
                    type: 'negative',
                    message: 'Something Error',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
        })
    },
    ShowAddModal () {
      this.AddModal = true
    },
    async SendAddData () {
      console.log(this.AddData)
      if (this.AddData.name.length < 3) {
        Notify.create({
              type: 'negative',
              message: 'The name must be at least 3 characters.',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
          
        return 0
      }
      this.$q.loading.show()

      await axios
        .post(
          'http://127.0.0.1:10/api/category/create_category',
          this.AddData
        )
        .then((res) => {
          
            Notify.create({
                    type: 'positive',
                    message: 'Succesfully Create Category Data',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
            this.AddData = {
              id: '',
              name: ''
            }
            this.AddModal = false
            this.categorys = []
            this.category()
            this.$q.loading.hide()

        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          if (this.AddData.name.length < 3) {
          Notify.create({
              type: 'negative',
              message: 'Something Error',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
          
        return 0
      }
        })
      this.$q.loading.hide()
    },
    ShowEditModal (data) {
      this.EditModal = true
      this.EditData = {
        id: data.id,
        name: data.name
      }
      console.log(this.EditData)
    },
    async SendEditData () {
      if (this.EditData.name.length < 3) {
        Notify.create({
              type: 'negative',
              message: 'The name must be at least 3 characters.',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
      this.$q.loading.show({
        delay: 400 // ms
      })
      await axios
        .post(
          'http://127.0.0.1:10/api/category/update_category',
          this.EditData
        )
        .then((res) => {
          if (res.status === 200) {
              Notify.create({
                    type: 'positive',
                    message: 'Succesfully Update Category Data',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
              })
            this.EditModal = false
            this.$q.loading.hide()
            this.categorys = []
            this.category()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          Notify.create({
                    type: 'negative',
                    message: 'Something Error',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
        })

      this.$q.loading.hide()
    },
    ShowDeleteModal (category) {
      this.DeleteData = {
        id: category.id,
        name: category.name
      }
      this.DeleteModal = true
    },
    async SendDeleteData () {
      this.$q.loading.show({
        delay: 400 // ms
      })
      await axios
        .post(
          'http://127.0.0.1:10/api/category/delete_category',
          this.DeleteData
        )
        .then((res) => {
          if (res.status === 200) {
            Notify.create({
                    type: 'positive',
                    message: 'Succesfully Delete category',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
              })
            this.DeleteModal = false
            this.categorys = []
            this.category()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          Notify.create({
                    type: 'negative',
                    message: 'Something Error',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
        })

      this.$q.loading.hide()
    },
    CloseAddModle () {
      this.AddModal = false
      this.AddData = {
        id: '',
        name: '',
        
      }
    },
    CloseEditModle () {
      this.EditModal = false
      this.AddData = {
        id: '',
        name: ''
      }
    },
    ShowMoreDeleteModal () {
      this.multiDeleteModal = true
    },
    async sendmultiDelete () {
      this.$q.loading.show()
      let sender = JSON.stringify(this.selected)
      await axios
        .post('http://127.0.0.1:10/api/category/multidelete', {
          data: sender
        })
        .then((res) => {
          if (res.status === 200) {
            Notify.create({
                    type: 'positive',
                    message: 'Succesfully Delete',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
              })
            this.multiDeleteModal = false
          }
        })
        .catch((e) => {
          var res = e.response
          if (res.status === 401) {
            this.auth()
          } else {
            Notify.create({
                    type: 'negative',
                    message: 'Something Error',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
          }
        })
      this.category()
      this.selected = []
      this.$q.loading.hide()
    },
    filterFn () {
      this.categorys = this.allcategorys.filter(v => v.name.toLowerCase().indexOf(this.search_text.toLowerCase()) > -1)
    },
    filter () {
      this.categorys = this.allcategorys
      this.search_text = ''
    }
  }
}
</script>
